import { parseLanguages, fetchLanguages } from "./orkg";

const content = [
  {
    id: "R601253",
    label: "MATLAB",
    classes: ["C29016"],
    shared: 1,
    featured: false,
    unlisted: false,
    verified: false,
    extraction_method: "UNKNOWN",
    _class: "resource",
    created_at: "2023-07-18T23:59:23.999205+02:00",
    created_by: "b5a8b9ab-e036-4cff-9f74-0d1f888ddb0c",
    observatory_id: "00000000-0000-0000-0000-000000000000",
    organization_id: "edc18168-c4ee-4cb8-a98a-136f748e912e",
    formatted_label: null,
  },
  {
    id: "R578227",
    label: "Shell",
    classes: ["C29016"],
    shared: 1,
    featured: false,
    unlisted: false,
    verified: false,
    extraction_method: "UNKNOWN",
    _class: "resource",
    created_at: "2023-03-27T18:28:36.110254+02:00",
    created_by: "b5a8b9ab-e036-4cff-9f74-0d1f888ddb0c",
    observatory_id: "00000000-0000-0000-0000-000000000000",
    organization_id: "edc18168-c4ee-4cb8-a98a-136f748e912e",
    formatted_label: null,
  },
  {
    id: "R202023",
    label: "Python 3",
    classes: ["C29016"],
    shared: 3,
    featured: false,
    unlisted: false,
    verified: false,
    extraction_method: "UNKNOWN",
    _class: "resource",
    created_at: "2022-07-25T09:53:01.536989Z",
    created_by: "7adcfc45-b315-4df7-b9a5-010e8f1ca9cb",
    observatory_id: "1afefdd0-5c09-4c9c-b718-2b35316b56f3",
    organization_id: "a4804f1d-4483-48be-8536-45068137dd7a",
    formatted_label: null,
  },
  {
    id: "R209881",
    label: "Python",
    classes: ["C29016"],
    shared: 15,
    featured: false,
    unlisted: false,
    verified: false,
    extraction_method: "UNKNOWN",
    _class: "resource",
    created_at: "2022-08-11T00:31:19.724863Z",
    created_by: "b5a8b9ab-e036-4cff-9f74-0d1f888ddb0c",
    observatory_id: "00000000-0000-0000-0000-000000000000",
    organization_id: "edc18168-c4ee-4cb8-a98a-136f748e912e",
    formatted_label: null,
  },
  {
    id: "R209882",
    label: "R",
    classes: ["C29016"],
    shared: 1,
    featured: false,
    unlisted: false,
    verified: false,
    extraction_method: "UNKNOWN",
    _class: "resource",
    created_at: "2022-08-11T00:32:58.331808Z",
    created_by: "b5a8b9ab-e036-4cff-9f74-0d1f888ddb0c",
    observatory_id: "00000000-0000-0000-0000-000000000000",
    organization_id: "edc18168-c4ee-4cb8-a98a-136f748e912e",
    formatted_label: null,
  },
  {
    id: "R583857",
    label: "Jupyter Notebook",
    classes: ["C29016"],
    shared: 2,
    featured: false,
    unlisted: false,
    verified: false,
    extraction_method: "UNKNOWN",
    _class: "resource",
    created_at: "2023-04-21T11:17:52.273636+02:00",
    created_by: "6cf402bc-5afb-4739-b4ba-d50ec5cbcd96",
    observatory_id: "00000000-0000-0000-0000-000000000000",
    organization_id: "00000000-0000-0000-0000-000000000000",
    formatted_label: null,
  },
  {
    id: "R226923",
    label: "C++",
    classes: ["C29016"],
    shared: 1,
    featured: false,
    unlisted: false,
    verified: false,
    extraction_method: "UNKNOWN",
    _class: "resource",
    created_at: "2022-10-25T13:07:22.236309Z",
    created_by: "7adcfc45-b315-4df7-b9a5-010e8f1ca9cb",
    observatory_id: "ae6d3307-fcda-4d8c-9c24-d1e2d6db91f2",
    organization_id: "edc18168-c4ee-4cb8-a98a-136f748e912e",
    formatted_label: null,
  },
  {
    id: "R226924",
    label: "Jupyter notebook",
    classes: ["C29016"],
    shared: 5,
    featured: false,
    unlisted: false,
    verified: false,
    extraction_method: "UNKNOWN",
    _class: "resource",
    created_at: "2022-10-25T13:07:51.987803Z",
    created_by: "7adcfc45-b315-4df7-b9a5-010e8f1ca9cb",
    observatory_id: "ae6d3307-fcda-4d8c-9c24-d1e2d6db91f2",
    organization_id: "edc18168-c4ee-4cb8-a98a-136f748e912e",
    formatted_label: null,
  },
  {
    id: "R227463",
    label: "HTML",
    classes: ["C29016"],
    shared: 1,
    featured: false,
    unlisted: false,
    verified: false,
    extraction_method: "UNKNOWN",
    _class: "resource",
    created_at: "2022-10-26T07:43:26.988176Z",
    created_by: "7adcfc45-b315-4df7-b9a5-010e8f1ca9cb",
    observatory_id: "ae6d3307-fcda-4d8c-9c24-d1e2d6db91f2",
    organization_id: "edc18168-c4ee-4cb8-a98a-136f748e912e",
    formatted_label: null,
  },
  {
    id: "R227462",
    label: "CSS",
    classes: ["C29016"],
    shared: 0,
    featured: false,
    unlisted: false,
    verified: false,
    extraction_method: "UNKNOWN",
    _class: "resource",
    created_at: "2022-10-26T07:43:10.897126Z",
    created_by: "7adcfc45-b315-4df7-b9a5-010e8f1ca9cb",
    observatory_id: "ae6d3307-fcda-4d8c-9c24-d1e2d6db91f2",
    organization_id: "edc18168-c4ee-4cb8-a98a-136f748e912e",
    formatted_label: null,
  },
  {
    id: "R604333",
    label: "Python",
    classes: ["C29016"],
    shared: 1,
    featured: false,
    unlisted: false,
    verified: false,
    extraction_method: "UNKNOWN",
    _class: "resource",
    created_at: "2023-08-07T14:03:29.067509+02:00",
    created_by: "768e8b20-d623-4ca0-9525-3c121e9d82b7",
    observatory_id: "00000000-0000-0000-0000-000000000000",
    organization_id: "00000000-0000-0000-0000-000000000000",
    formatted_label: null,
  },
  {
    id: "R604408",
    label: "Python",
    classes: ["C29016"],
    shared: 1,
    featured: false,
    unlisted: false,
    verified: false,
    extraction_method: "UNKNOWN",
    _class: "resource",
    created_at: "2023-08-10T12:35:32.038243+02:00",
    created_by: "768e8b20-d623-4ca0-9525-3c121e9d82b7",
    observatory_id: "00000000-0000-0000-0000-000000000000",
    organization_id: "00000000-0000-0000-0000-000000000000",
    formatted_label: null,
  },
  {
    id: "R604484",
    label: "Python",
    classes: ["C29016"],
    shared: 1,
    featured: false,
    unlisted: false,
    verified: false,
    extraction_method: "UNKNOWN",
    _class: "resource",
    created_at: "2023-08-12T10:55:57.680646+02:00",
    created_by: "768e8b20-d623-4ca0-9525-3c121e9d82b7",
    observatory_id: "00000000-0000-0000-0000-000000000000",
    organization_id: "00000000-0000-0000-0000-000000000000",
    formatted_label: null,
  },
  {
    id: "R604489",
    label: "Python",
    classes: ["C29016"],
    shared: 1,
    featured: false,
    unlisted: false,
    verified: false,
    extraction_method: "UNKNOWN",
    _class: "resource",
    created_at: "2023-08-12T10:58:47.966752+02:00",
    created_by: "768e8b20-d623-4ca0-9525-3c121e9d82b7",
    observatory_id: "00000000-0000-0000-0000-000000000000",
    organization_id: "00000000-0000-0000-0000-000000000000",
    formatted_label: null,
  },
];

describe("parseLanguages", () => {
  it("should parse instances of the language class from orkg and return the result", async () => {
    const result = parseLanguages(content);
    expect(result).toEqual([
      {
        id: "R226923",
        label: "C++",
        shared: 1,
      },
      {
        id: "R227462",
        label: "CSS",
        shared: 0,
      },
      {
        id: "R227463",
        label: "HTML",
        shared: 1,
      },
      {
        id: "R226924",
        label: "Jupyter notebook",
        shared: 5,
      },
      {
        id: "R601253",
        label: "MATLAB",
        shared: 1,
      },
      {
        id: "R209881",
        label: "Python",
        shared: 15,
      },
      {
        id: "R202023",
        label: "Python 3",
        shared: 3,
      },
      {
        id: "R209882",
        label: "R",
        shared: 1,
      },
      {
        id: "R578227",
        label: "Shell",
        shared: 1,
      },
    ]);
  });
});

const firstResponse = new Response(
  JSON.stringify({
    content: [
      {
        id: "R267015",
        label: "Shell",
        classes: ["C29016"],
        shared: 1,
        featured: false,
        unlisted: false,
        verified: false,
        extraction_method: "UNKNOWN",
        _class: "resource",
        created_at: "2023-02-28T06:09:41.023885Z",
        created_by: "b5a8b9ab-e036-4cff-9f74-0d1f888ddb0c",
        observatory_id: "00000000-0000-0000-0000-000000000000",
        organization_id: "edc18168-c4ee-4cb8-a98a-136f748e912e",
        formatted_label: null,
      },
      {
        id: "R202023",
        label: "Python 3",
        classes: ["C29016"],
        shared: 5,
        featured: false,
        unlisted: false,
        verified: false,
        extraction_method: "UNKNOWN",
        _class: "resource",
        created_at: "2022-07-25T09:53:01.536989Z",
        created_by: "7adcfc45-b315-4df7-b9a5-010e8f1ca9cb",
        observatory_id: "1afefdd0-5c09-4c9c-b718-2b35316b56f3",
        organization_id: "a4804f1d-4483-48be-8536-45068137dd7a",
        formatted_label: null,
      },
    ],
    pageable: {
      sort: { unsorted: true, sorted: false, empty: true },
      pageNumber: 0,
      pageSize: 2,
      offset: 0,
      paged: true,
      unpaged: false,
    },
    totalElements: 5,
    totalPages: 3,
    last: false,
    first: true,
    sort: { unsorted: true, sorted: false, empty: true },
    numberOfElements: 2,
    size: 2,
    number: 0,
    empty: false,
  })
);
const secondResponse = new Response(
  JSON.stringify({
    content: [
      {
        id: "R209881",
        label: "Python",
        classes: ["C29016"],
        shared: 8,
        featured: false,
        unlisted: false,
        verified: false,
        extraction_method: "UNKNOWN",
        _class: "resource",
        created_at: "2022-08-11T00:31:19.724863Z",
        created_by: "b5a8b9ab-e036-4cff-9f74-0d1f888ddb0c",
        observatory_id: "00000000-0000-0000-0000-000000000000",
        organization_id: "edc18168-c4ee-4cb8-a98a-136f748e912e",
        formatted_label: null,
      },
      {
        id: "R209882",
        label: "R",
        classes: ["C29016"],
        shared: 1,
        featured: false,
        unlisted: false,
        verified: false,
        extraction_method: "UNKNOWN",
        _class: "resource",
        created_at: "2022-08-11T00:32:58.331808Z",
        created_by: "b5a8b9ab-e036-4cff-9f74-0d1f888ddb0c",
        observatory_id: "00000000-0000-0000-0000-000000000000",
        organization_id: "edc18168-c4ee-4cb8-a98a-136f748e912e",
        formatted_label: null,
      },
    ],
    pageable: {
      sort: { unsorted: true, sorted: false, empty: true },
      pageNumber: 1,
      pageSize: 2,
      offset: 2,
      paged: true,
      unpaged: false,
    },
    totalElements: 5,
    totalPages: 3,
    last: false,
    first: false,
    sort: { unsorted: true, sorted: false, empty: true },
    numberOfElements: 2,
    size: 2,
    number: 1,
    empty: false,
  })
);
const thirdResponse = new Response(
  JSON.stringify({
    content: [
      {
        id: "R281157",
        label: "Javascript",
        classes: ["C29016"],
        shared: 2,
        featured: false,
        unlisted: false,
        verified: false,
        extraction_method: "UNKNOWN",
        _class: "resource",
        created_at: "2023-04-20T14:33:39.963023+02:00",
        created_by: "6be80860-a07d-4791-a67a-178f0249d412",
        observatory_id: "00000000-0000-0000-0000-000000000000",
        organization_id: "00000000-0000-0000-0000-000000000000",
        formatted_label: null,
      },
    ],
    pageable: {
      sort: { unsorted: true, sorted: false, empty: true },
      pageNumber: 2,
      pageSize: 2,
      offset: 4,
      paged: true,
      unpaged: false,
    },
    totalElements: 5,
    totalPages: 3,
    last: false,
    first: false,
    sort: { unsorted: true, sorted: false, empty: true },
    numberOfElements: 2,
    size: 2,
    number: 2,
    empty: false,
  })
);

global.fetch = jest
  .fn()
  .mockResolvedValueOnce(firstResponse)
  .mockResolvedValueOnce(secondResponse)
  .mockResolvedValueOnce(thirdResponse);

test("test fetchLanguages with multiple pages", async () => {
  const result = await fetchLanguages("https://sandbox.orkg.org", 2);
  expect(result).toEqual([
    {
      id: "R267015",
      label: "Shell",
      classes: ["C29016"],
      shared: 1,
      featured: false,
      unlisted: false,
      verified: false,
      extraction_method: "UNKNOWN",
      _class: "resource",
      created_at: "2023-02-28T06:09:41.023885Z",
      created_by: "b5a8b9ab-e036-4cff-9f74-0d1f888ddb0c",
      observatory_id: "00000000-0000-0000-0000-000000000000",
      organization_id: "edc18168-c4ee-4cb8-a98a-136f748e912e",
      formatted_label: null,
    },
    {
      id: "R202023",
      label: "Python 3",
      classes: ["C29016"],
      shared: 5,
      featured: false,
      unlisted: false,
      verified: false,
      extraction_method: "UNKNOWN",
      _class: "resource",
      created_at: "2022-07-25T09:53:01.536989Z",
      created_by: "7adcfc45-b315-4df7-b9a5-010e8f1ca9cb",
      observatory_id: "1afefdd0-5c09-4c9c-b718-2b35316b56f3",
      organization_id: "a4804f1d-4483-48be-8536-45068137dd7a",
      formatted_label: null,
    },
    {
      id: "R209881",
      label: "Python",
      classes: ["C29016"],
      shared: 8,
      featured: false,
      unlisted: false,
      verified: false,
      extraction_method: "UNKNOWN",
      _class: "resource",
      created_at: "2022-08-11T00:31:19.724863Z",
      created_by: "b5a8b9ab-e036-4cff-9f74-0d1f888ddb0c",
      observatory_id: "00000000-0000-0000-0000-000000000000",
      organization_id: "edc18168-c4ee-4cb8-a98a-136f748e912e",
      formatted_label: null,
    },
    {
      id: "R209882",
      label: "R",
      classes: ["C29016"],
      shared: 1,
      featured: false,
      unlisted: false,
      verified: false,
      extraction_method: "UNKNOWN",
      _class: "resource",
      created_at: "2022-08-11T00:32:58.331808Z",
      created_by: "b5a8b9ab-e036-4cff-9f74-0d1f888ddb0c",
      observatory_id: "00000000-0000-0000-0000-000000000000",
      organization_id: "edc18168-c4ee-4cb8-a98a-136f748e912e",
      formatted_label: null,
    },
    {
      id: "R281157",
      label: "Javascript",
      classes: ["C29016"],
      shared: 2,
      featured: false,
      unlisted: false,
      verified: false,
      extraction_method: "UNKNOWN",
      _class: "resource",
      created_at: "2023-04-20T14:33:39.963023+02:00",
      created_by: "6be80860-a07d-4791-a67a-178f0249d412",
      observatory_id: "00000000-0000-0000-0000-000000000000",
      organization_id: "00000000-0000-0000-0000-000000000000",
      formatted_label: null,
    },
  ]);
});
